
local pvpdiff = {
    [116] = {["edits"] = {{9,15.0}}, ["text"] = "Launches a bolt of frost at the enemy, causing |cFFFFFF00(+15.0%)|r Frost damage and slowing movement speed by 50% for 8 sec."},  
    [1714] = {["edits"] = {{15,-50.0}}, ["text"] = "Forces the target to speak in Demonic, increasing the casting time of all spells by |cFFFF0000(-50.0%)|r for 1 min.\r\n\r\n|cFF8282FFCurses: A warlock can only have one Curse active per target.|r"},  
    [1784] = {["edits"] = {{29,-50.0}}, ["text"] = "Conceals you in the shadows until cancelled, allowing you to stalk enemies without being seen. Movement speed while stealthed is increased by 20% and damage dealt is increased by |cFFFF0000(-50.0%)|r"},  
    [1943] = {["edits"] = {{23,-5.5},{31,-5.5},{39,-5.5},{47,-5.5},{55,-5.5}}, ["text"] = "Finishing move that tears open the target, dealing Bleed damage over time. Lasts longer per combo point.\r\n\r\n   1 point  : |cFFFF0000(-5.5%)|r over 8 sec\r\n   2 points: |cFFFF0000(-5.5%)|r over 12 sec\r\n   3 points: |cFFFF0000(-5.5%)|r over 16 sec\r\n   4 points: |cFFFF0000(-5.5%)|r over 20 sec\r\n   5 points: |cFFFF0000(-5.5%)|r over 24 sec"},  
    [2060] = {["edits"] = {{8,20.0}}, ["text"] = "An efficient spell that heals an ally for |cFFFFFF00(+20.0%)|r"},  
    [8042] = {["edits"] = {{8,-10.0}}, ["text"] = "Instantly shocks the target with concussive force, causing |cFFFF0000(-10.0%)|r Nature damage."},  
    [8679] = {["edits"] = {{34,-50.0}}, ["text"] = "Coats your weapons with a Lethal Poison that lasts for 1 |4hour:hrs;. Each strike has a 30% chance to poison the enemy, which instantly inflicts 46 Nature damage and reduces all healing received by |cFFFF0000(-50.0%)|r for 12 sec, stacking up to 3 times."},  
    [12042] = {["edits"] = {{5,-33.3}}, ["text"] = "For 10 sec, you deal |cFFFF0000(-33.3%)|r more spell damage."},  
    [22568] = {["edits"] = {{29,-20.1},{35,-20.1},{41,-20.0},{47,-20.0},{53,-20.0}}, ["text"] = "Finishing move that causes Physical damage per combo point and consumes up to 25 additional Energy to increase damage by up to 100%.\r\n\r\n   1 point  : |cFFFF0000(-20.1%)|r damage\r\n   2 points: |cFFFF0000(-20.1%)|r damage\r\n   3 points: |cFFFF0000(-20.0%)|r damage\r\n   4 points: |cFFFF0000(-20.0%)|r damage\r\n   5 points: |cFFFF0000(-20.0%)|r damage"},  
    [30213] = {["edits"] = {{25,-50.0}}, ["text"] = "A strong attack that deals 160 damage to all enemies in front of it, and reduces the effectiveness of any healing the victim receives by |cFFFF0000(-50.0%)|r for 6 sec.\r\n\r\n|cFF777777(Right-Click to toggle)|r"},  
    [32645] = {["edits"] = {{34,-5.5},{42,-5.5},{50,-5.5},{58,-5.5},{66,-5.6}}, ["text"] = "Finishing move that drives your poisoned blades in deep, dealing instant Nature damage and increasing your poison application chance by 30%. Damage and duration increased per combo point.\r\n\r\n   1 point  : |cFFFF0000(-5.5%)|r damage, 2 sec\r\n   2 points: |cFFFF0000(-5.5%)|r damage, 3 sec\r\n   3 points: |cFFFF0000(-5.5%)|r damage, 4 sec\r\n   4 points: |cFFFF0000(-5.5%)|r damage, 5 sec\r\n   5 points: |cFFFF0000(-5.6%)|r damage, 6 sec"},  
    [45470] = {["edits"] = {{15,-52.0},{26,-50.0}}, ["text"] = "Focuses dark power into a strike that deals 833 Physical damage and heals you for |cFFFF0000(-52.0%)|r of all damage taken in the last 5 sec, minimum |cFFFF0000(-50.0%)|r of maximum health."},  
    [49998] = {["edits"] = {{15,-52.0},{26,-50.0}}, ["text"] = "Focuses dark power into a strike that deals 833 Physical damage and heals you for |cFFFF0000(-52.0%)|r of all damage taken in the last 5 sec, minimum |cFFFF0000(-50.0%)|r of maximum health."},  
    [51271] = {["edits"] = {{8,-40.0}}, ["text"] = "The power of frost increases your Strength by |cFFFF0000(-40.0%)|r for 12 sec.\r\n\r\nEach Rune spent while active increases your Strength by an additional 1%."},  
    [56641] = {["edits"] = {{5,10.0}}, ["text"] = "A steady shot that causes |cFFFFFF00(+10.0%)|r Physical damage.\r\n\r\nUsable while moving."},  
    [66188] = {["edits"] = {{15,-52.0},{26,-50.0}}, ["text"] = "Focuses dark power into a strike that deals 833 Physical damage and heals you for |cFFFF0000(-52.0%)|r of all damage taken in the last 5 sec, minimum |cFFFF0000(-50.0%)|r of maximum health."},  
    [77472] = {["edits"] = {{8,9.9}}, ["text"] = "An efficient wave of healing energy that restores |cFFFFFF00(+9.9%)|r of a friendly target’s health."},  
    [116011] = {["edits"] = {{17,-25.0}}, ["text"] = "Places a Rune of Power on the ground for 12 sec which increases your spell damage by |cFFFF0000(-25.0%)|r while you stand within 8 yds.\r\n\r\nCasting Icy Veins will also create a Rune of Power at your location."},  
    [116014] = {["edits"] = {{17,-25.0}}, ["text"] = "Places a Rune of Power on the ground for 12 sec which increases your spell damage by |cFFFF0000(-25.0%)|r while you stand within 8 yds.\r\n\r\nCasting Icy Veins will also create a Rune of Power at your location."},  
    [116858] = {["edits"] = {{11,15.0}}, ["text"] = "Unleashes a devastating blast of chaos, dealing a critical strike for |cFFFFFF00(+15.0%)|r Chaos damage. Damage is further increased by your critical strike chance."},  
    [121471] = {["edits"] = {{22,-40.0}}, ["text"] = "Draws upon surrounding shadows to empower your weapons, causing your combo point generating abilities to generate 1 additional combo point and deal |cFFFF0000(-40.0%)|r additional damage as Shadow for 20 sec."},  
    [153561] = {["edits"] = {{14,-20.0},{30,-20.1}}, ["text"] = "Calls down a meteor which lands at the target location after 3 sec, dealing |cFFFF0000(-20.0%)|r Fire damage, split evenly between all targets within 8 yards, and burns the ground, dealing |cFFFF0000(-20.1%)|r Fire damage over 8.5 sec to all enemies in the area. "},  
    [153564] = {["edits"] = {{14,-20.0},{30,-20.1}}, ["text"] = "Calls down a meteor which lands at the target location after 3 sec, dealing |cFFFF0000(-20.0%)|r Fire damage, split evenly between all targets within 8 yards, and burns the ground, dealing |cFFFF0000(-20.1%)|r Fire damage over 8.5 sec to all enemies in the area. "},  
    [153595] = {["edits"] = {{17,-10.0}}, ["text"] = "Calls down a series of 7 icy comets on and around the target, that deals up to |cFFFF0000(-10.0%)|r Frost damage to all enemies within 6 yds of its impacts."},  
    [153596] = {["edits"] = {{17,-10.0}}, ["text"] = "Calls down a series of 7 icy comets on and around the target, that deals up to |cFFFF0000(-10.0%)|r Frost damage to all enemies within 6 yds of its impacts."},  
    [155158] = {["edits"] = {{14,-20.0},{30,-20.1}}, ["text"] = "Calls down a meteor which lands at the target location after 3 sec, dealing |cFFFF0000(-20.0%)|r Fire damage, split evenly between all targets within 8 yards, and burns the ground, dealing |cFFFF0000(-20.1%)|r Fire damage over 8.5 sec to all enemies in the area. "},  
    [158188] = {["edits"] = {{29,-50.0}}, ["text"] = "Conceals you in the shadows until cancelled, allowing you to stalk enemies without being seen. Movement speed while stealthed is increased by 20% and damage dealt is increased by |cFFFF0000(-50.0%)|r"},  
    [183998] = {["edits"] = {{13,-25.0}}, ["text"] = "Sacrifice a portion of your own health to instantly heal an ally for |cFFFF0000(-25.0%)|r You take damage equal to 50% of the healing done.\r\n\r\nDoes not cause your Beacon of Light to be healed. Cannot be cast on yourself."},  
    [185313] = {["edits"] = {{44,-50.0}}, ["text"] = "Allows use of all Stealth abilities and grants all the combat benefits of Stealth for 8 sec, and increases damage by 15%. Effect not broken from taking damage or attacking. Movement speed while active is increased by 20% and damage dealt is increased by |cFFFF0000(-50.0%)|r "},  
    [191634] = {["edits"] = {{12,-23.3}}, ["text"] = "Charge yourself with lightning, causing your next 2 Lightning Bolts to deal |cFFFF0000(-23.3%)|r more damage, and also causes your next 2 Lightning Bolts or Chain Lightnings to be instant cast and trigger an Elemental Overload on every target."},  
    [196819] = {["edits"] = {{28,-5.6},{34,-5.5},{40,-5.6},{46,-5.5},{52,-5.5}}, ["text"] = "Finishing move that disembowels the target, causing damage per combo point. Targets with Find Weakness suffer an additional 50% damage as Shadow.\r\n   1 point  : |cFFFF0000(-5.6%)|r damage\r\n   2 points: |cFFFF0000(-5.5%)|r damage\r\n   3 points: |cFFFF0000(-5.6%)|r damage\r\n   4 points: |cFFFF0000(-5.5%)|r damage\r\n   5 points: |cFFFF0000(-5.5%)|r damage"},  
    [196917] = {["edits"] = {{13,-25.0}}, ["text"] = "Sacrifice a portion of your own health to instantly heal an ally for |cFFFF0000(-25.0%)|r You take damage equal to 50% of the healing done.\r\n\r\nDoes not cause your Beacon of Light to be healed. Cannot be cast on yourself."},  
    [202497] = {["edits"] = {{21,-33.3}}, ["text"] = "Moonfire and Sunfire damage over time has a chance to call down a falling star, dealing 141 Astral damage and generating |cFFFF0000(-33.3%)|r Astral Power."},  
    [223819] = {["edits"] = {{17,-35.0}}, ["text"] = "Holy Power abilities have a 15% chance to make your next Holy Power ability free and deal |cFFFF0000(-35.0%)|r increased damage and healing."},  
    [228597] = {["edits"] = {{9,15.0}}, ["text"] = "Launches a bolt of frost at the enemy, causing |cFFFFFF00(+15.0%)|r Frost damage and slowing movement speed by 50% for 8 sec."},  
    [255937] = {["edits"] = {{6,-25.0}}, ["text"] = "Lash out at your enemies, dealing |cFFFF0000(-25.0%)|r Radiant damage to all enemies within 12 yd in front of you and reducing their movement speed by 50% for 5 sec. Damage reduced on secondary targets.\r\n\r\nDemon and Undead enemies are also stunned for 5 sec.\r\n\r\n|cFFFFFFFFGenerates 3 Holy Power."},  
    [255941] = {["edits"] = {{6,-25.0}}, ["text"] = "Lash out at your enemies, dealing |cFFFF0000(-25.0%)|r Radiant damage to all enemies within 12 yd in front of you and reducing their movement speed by 50% for 5 sec. Damage reduced on secondary targets.\r\n\r\nDemon and Undead enemies are also stunned for 5 sec.\r\n\r\n|cFFFFFFFFGenerates 3 Holy Power."},  
    [256896] = {["edits"] = {{1,-50.0}}, ["text"] = "Deals |cFFFF0000(-50.0%)|r Holy Damage to enemies within 5.\r\n\r\nHeals 2,875 to allies within 5. "},  
    [262115] = {["edits"] = {{10,-25.1}}, ["text"] = "Mortal Strike, Colossus Smash, and Bladestorm inflict Deep Wounds, dealing |cFFFF0000(-25.1%)|r Bleed damage over 12 sec and increasing the damage the enemy takes from you by 17.3%."},  
    [267611] = {["edits"] = {{11,-33.3}}, ["text"] = "Templar's Verdict increases the damage of your next Templar's Verdict by |cFFFF0000(-33.3%)|r for 6 sec."},  
    [279302] = {["edits"] = {{16,-66.7}}, ["text"] = "Summons a frostwyrm who breathes on all enemies within 40 yd in front of you, dealing |cFFFF0000(-66.7%)|r Frost damage and slowing movement speed by 50% for 10 sec."},  
    [279303] = {["edits"] = {{16,-66.7}}, ["text"] = "Summons a frostwyrm who breathes on all enemies within 40 yd in front of you, dealing |cFFFF0000(-66.7%)|r Frost damage and slowing movement speed by 50% for 10 sec."},  
    [316220] = {["edits"] = {{18,-35.0}}, ["text"] = "Your Shadowstrike and Cheap Shot reveal a flaw in your target's defenses, causing all your attacks to bypass |cFFFF0000(-35.0%)|r of that enemy's armor for 10 sec."},  
    [319175] = {["edits"] = {{34,-5.7},{40,-5.7},{46,-5.5},{52,-5.5},{58,-5.6}}, ["text"] = "Finishing move that launches explosive Black Powder at up to 8 nearby targets dealing Physical damage. Targets with your Find Weakness suffer an additional 50% damage as Shadow.\r\n\r\n   1 point  : |cFFFF0000(-5.7%)|r damage\r\n   2 points: |cFFFF0000(-5.7%)|r damage\r\n   3 points: |cFFFF0000(-5.5%)|r damage\r\n   4 points: |cFFFF0000(-5.5%)|r damage\r\n   5 points: |cFFFF0000(-5.6%)|r damage\r\n"},  
    [319233] = {["edits"] = {{36,-40.0}}, ["text"] = "Dark Transformation creates an unholy pact between you and your pet, igniting flaming chains that deal 4,238 Shadow damage over 15 sec to enemies between you and your pet. \r\n\r\nWhile active, your strength is increased by |cFFFF0000(-40.0%)|r"},  
    [319236] = {["edits"] = {{36,-40.0}}, ["text"] = "Dark Transformation creates an unholy pact between you and your pet, igniting flaming chains that deal 4,238 Shadow damage over 15 sec to enemies between you and your pet. \r\n\r\nWhile active, your strength is increased by |cFFFF0000(-40.0%)|r"},  
    [319238] = {["edits"] = {{36,-40.0}}, ["text"] = "Dark Transformation creates an unholy pact between you and your pet, igniting flaming chains that deal 4,238 Shadow damage over 15 sec to enemies between you and your pet. \r\n\r\nWhile active, your strength is increased by |cFFFF0000(-40.0%)|r"},  
    [319245] = {["edits"] = {{36,-40.0}}, ["text"] = "Dark Transformation creates an unholy pact between you and your pet, igniting flaming chains that deal 4,238 Shadow damage over 15 sec to enemies between you and your pet. \r\n\r\nWhile active, your strength is increased by |cFFFF0000(-40.0%)|r"},  
    [319255] = {["edits"] = {{36,-40.0}}, ["text"] = "Dark Transformation creates an unholy pact between you and your pet, igniting flaming chains that deal 4,238 Shadow damage over 15 sec to enemies between you and your pet. \r\n\r\nWhile active, your strength is increased by |cFFFF0000(-40.0%)|r"},  
    [319504] = {["edits"] = {{21,-33.3}}, ["text"] = "Stab your enemy with a toxic poisoned blade, dealing 1,150 Nature damage.\r\n\r\nYour Nature damage done against the target is increased by |cFFFF0000(-33.3%)|r for 9 sec.\r\n\r\n|cFFFFFFFFAwards 1 combo point.|r"},  
    [320137] = {["edits"] = {{12,-23.3}}, ["text"] = "Charge yourself with lightning, causing your next 2 Chain Lightnings to deal |cFFFF0000(-23.3%)|r more damage and be instant cast."},  
    [323547] = {["edits"] = {{1,-50.0}}, ["text"] = "Deal |cFFFF0000(-50.0%)|r Arcane damage to an enemy, extracting their anima to Animacharge a combo point for 45 sec.\r\n\r\nDamaging finishing moves that consume the same number of combo points as your Animacharge function as if they consumed 7 combo points.\r\n\r\n|cFFFFFFFFAwards 2 combo points.|r\r\n"},  
    [323558] = {["edits"] = {{1,-50.0}}, ["text"] = "Deal |cFFFF0000(-50.0%)|r Arcane damage to an enemy, extracting their anima to Animacharge a combo point for 45 sec.\r\n\r\nDamaging finishing moves that consume the same number of combo points as your Animacharge function as if they consumed 7 combo points.\r\n\r\n|cFFFFFFFFAwards 2 combo points.|r\r\n"},  
    [328908] = {["edits"] = {{6,-50.0}}, ["text"] = "Echoing Reprimand increases your Mastery by |cFFFF0000(-50.0%)|r for 7.5 sec and occasionally expels Sorrowful Memories. \r\n\r\nWalking through Sorrowful Memories extends this effect by 2.3 sec. "},  
    [329840] = {["edits"] = {{1,-60.1}}, ["text"] = "Inflict |cFFFF0000(-60.1%)|r Shadow damage split between all nearby enemies, and form a Blood Barrier on yourself. The Blood Barrier absorbs 4,687 damage for 10 sec.\r\n\r\nDamage and absorption are increased for each enemy struck, up to 5 enemies."},  
    [329849] = {["edits"] = {{1,-60.1}}, ["text"] = "Inflict |cFFFF0000(-60.1%)|r Shadow damage split between all nearby enemies, and form a Blood Barrier on yourself. The Blood Barrier absorbs 4,687 damage for 10 sec.\r\n\r\nDamage and absorption are increased for each enemy struck, up to 5 enemies."},  
    [332777] = {["edits"] = {{23,-44.4}}, ["text"] = "Each time Arcane Missiles hits an enemy, the damage of your next Arcane Barrage is increased by 8%. This effect stacks up to |cFFFF0000(-44.4%)|r times."},  
    [338041] = {["edits"] = {{26,NaN}}, ["text"] = "Form a connection with your inner self. Every 1 min, you may empower the connection for 10 sec, granting you an effect based on your role.\r\n\r\n|cFFFFFFFFTank|r\r\n|T3528282:24|t|cffffffffLone |cFFFF0000(NaN%)|r"},  
    [343527] = {["edits"] = {{15,-24.0}}, ["text"] = "A hammer slowly falls from the sky upon the target. After 8 sec, they suffer |cFFFF0000(-24.0%)|r Holy damage, plus 20% of damage taken from your abilities in that time."},  
    [344662] = {["edits"] = {{9,-20.1}}, ["text"] = "Your next 5 damaging abilities inflict Shattered Psyche, dealing |cFFFF0000(-20.1%)|r Shadow damage and increasing the target's damage taken from Shattered Psyche by 1% for 5 sec, stacking up to 25 times."},  
    [344663] = {["edits"] = {{9,-20.1}}, ["text"] = "Your next 5 damaging abilities inflict Shattered Psyche, dealing |cFFFF0000(-20.1%)|r Shadow damage and increasing the target's damage taken from Shattered Psyche by 1% for 5 sec, stacking up to 25 times."},  
    [344664] = {["edits"] = {{9,-20.1}}, ["text"] = "Your next 5 damaging abilities inflict Shattered Psyche, dealing |cFFFF0000(-20.1%)|r Shadow damage and increasing the target's damage taken from Shattered Psyche by 1% for 5 sec, stacking up to 25 times."},  
    [344732] = {["edits"] = {{7,-55.0}}, ["text"] = "Unleash incendiary flames at your target inflicting |cFFFF0000(-55.0%)|r Fire damage."},  
    [349857] = {["edits"] = {{7,-55.0}}, ["text"] = "Unleash incendiary flames at your target inflicting |cFFFF0000(-55.0%)|r Fire damage."},  
    [351140] = {["edits"] = {{14,-20.0},{30,-20.1}}, ["text"] = "Calls down a meteor which lands at the target location after 3 sec, dealing |cFFFF0000(-20.0%)|r Fire damage, split evenly between all targets within 8 yards, and burns the ground, dealing |cFFFF0000(-20.1%)|r Fire damage over 8.5 sec to all enemies in the area. "},  
    
}

function strjoin(delimiter, list)
    local len = getn(list)
    if len == 0 then
       return "" 
    end
    local string = list[1]
    for i = 2, len do 
       string = string .. delimiter .. list[i] 
    end
    return string
 end

 
function strsplit(delimiter, text)
    local list = {}
    local pos = 1
    if strfind("", delimiter, 1) then -- this would result in endless loops
       error("delimiter matches empty string!")
    end
    while 1 do
       local first, last = strfind(text, delimiter, pos)
       if first then -- found?
          tinsert(list, strsub(text, pos, first-1))
          pos = last+1
       else
          tinsert(list, strsub(text, pos))
          break
       end
    end
    return list
 end

local function UpdateTooltip(id)
	-- If spellId was not passed, search for it
	if not id then
		local _, spellId = GameTooltip:GetSpell();
		id = spellId;
	end

    if pvpdiff[id] then
        GameTooltip:AddLine("\r\nIn PvP: ", 1, 0.3, 0.3);
        GameTooltip:AddLine("SpellId: " .. id, 0.62, 0.62, 0.62);
        GameTooltip:AddLine(pvpdiff[id]["text"], 0.90, 0.80, 0.50,  0)
        GameTooltip:AddLine("PvP tooltips brought to you by wowarenalogs.com", 1, 0.5, 0.0);
    else 
        GameTooltip:AddLine("SpellId: " .. id, 0.62, 0.62, 0.62);
    end
	GameTooltip:Show();
end

do
	hooksecurefunc(GameTooltip, "SetAction", function() UpdateTooltip(); end);
	hooksecurefunc(GameTooltip, "SetSpellBookItem", function() UpdateTooltip(); end);
	hooksecurefunc(GameTooltip, "SetSpellByID", function() UpdateTooltip(); end);
	hooksecurefunc(GameTooltip, "SetTalent", function() UpdateTooltip(); end);
	hooksecurefunc(GameTooltip, "SetShapeshift", function() UpdateTooltip(); end);
end



-- MACRO ADDON USED TO GENERATE DIFF SAVED VARS
-- YOU WILL NEED TO SOURCE SPELL ID LIST YOURSELF, ITS HUGE!
-- local ids  = {}
-- local frame = CreateFrame("FRAME");
-- frame:RegisterEvent("ADDON_LOADED");

-- function frame:OnEvent(event, arg1)
-- 	if event == "ADDON_LOADED" and arg1 == "ArenaPlaybooks" then
-- 		print(tooltipMine)
-- 		for k, v in ipairs(tooltipMine) do
-- 			print(k)
-- 			print(v)
-- 		end
-- 		tooltipMine = {
-- 			["all_pvp"] = {},
-- 			["all_pve"] = {},
-- 			["diff_pvp"] = {},
-- 		};
-- 	end
-- end
-- frame:SetScript("OnEvent", frame.OnEvent);

-- desc = ""
-- SLASH_APLAY1 = "/aplay"
-- SLASH_APLAY2 = "/apl"
-- SlashCmdList["APLAY"] = function(msg)
-- 	if (msg == "pvp") then
-- 		for _, spellid in ipairs(ids) do
-- 			local spell = Spell:CreateFromSpellID(spellid)
-- 			spell:ContinueOnSpellLoad(function()
-- 				local name = spell:GetSpellName()
-- 				local desc = spell:GetSpellDescription()
-- 				if string.len(desc) > 0 then
-- 					tooltipMine["all_pvp"][spellid] = desc
-- 				end
-- 				print(name)
-- 			end)
-- 		end
-- 	elseif (msg == "pve") then
-- 		for _, spellid in ipairs(ids) do
-- 			local spell = Spell:CreateFromSpellID(spellid)
-- 			spell:ContinueOnSpellLoad(function()
-- 				local name = spell:GetSpellName()
-- 				local desc = spell:GetSpellDescription()
-- 				if string.len(desc) > 0 then
-- 					tooltipMine["all_pve"][spellid] = desc
-- 				end
-- 				print(name)
-- 			end)
-- 		end
-- 	elseif (msg == "diff") then
-- 		for _, spellid in ipairs(ids) do
-- 			if tooltipMine["all_pvp"][spellid] ~= nil and string.len(tooltipMine["all_pvp"][spellid]) > 0 then
-- 				if tooltipMine["all_pve"][spellid] ~= nil and string.len(tooltipMine["all_pve"][spellid]) > 0 then
-- 					if tooltipMine["all_pve"][spellid] ~= tooltipMine["all_pvp"][spellid] then
-- 						tooltipMine["diff_pvp"][spellid] = GetSpellDescription(spellid)
-- 					end
-- 				end
-- 			end
-- 		end
-- 	else
-- 		print("Invalid command")
-- 	end
-- end

-- JAVASCRIPT USED TO COMPUTE DIFF PRETTIER:
-- const console = require("console");
-- var fs = require("fs");
-- var data = require("./spelldiff.json");

-- function makeYellow(s) {
--   return `|cFFFFFF00${s}|r`;
-- }

-- function makeGreen(s) {
--   return `|cFFFFFF00${s}|r`;
-- }

-- function makeRed(s) {
--   return `|cFFFF0000${s}|r`;
-- }

-- console.log(Object.keys(data));

-- const all_pve = data["all_pve"];
-- const all_pvp = data["all_pvp"];
-- const diff_pvp = data["diff_pvp"];
-- const diffed_pvp = {};

-- console.log(Object.keys(all_pve).length);
-- console.log(Object.keys(all_pvp).length);
-- console.log(Object.keys(diff_pvp).length);

-- var blanks = 0;

-- for (let k of Object.keys(diff_pvp)) {
--   if (diff_pvp[k] === "") {
--     blanks++;
--     continue;
--   }
--   const pve_words = all_pve[k].split(" ");
--   const pvp_words = all_pvp[k].split(" ");

--   const new_words = [];
--   const edits = [];

--   for (let i = 0; i < pvp_words.length; i++) {
--     if (pve_words.length < i - 1 || pve_words[i] !== pvp_words[i]) {
--       try {
--         let f1 = parseFloat(pve_words[i].replace(/,/g, ""));
--         let f2 = parseFloat(pvp_words[i].replace(/,/g, ""));
--         const loss = ((100 * (f2 - f1)) / f1).toFixed(1);
--         if (loss > 0) {
--           new_words.push(makeGreen(`(+${loss}%)`));
--         } else {
--           new_words.push(makeRed(`(${loss}%)`));
--         }
--         console.log(pve_words[i], pvp_words[i], f1, f2, loss);
--         edits.push([i, ((100 * (f2 - f1)) / f1).toFixed(1)]);
--       } catch (error) {
--         console.log(error);
--         new_words.push(pvp_words[i]);
--       }
--     } else {
--       new_words.push(pvp_words[i]);
--     }
--   }
--   diffed_pvp[k] = {
--     edits: edits,
--     new_words: new_words.join(" ").replace(/\n/g, "\\n").replace(/\r/g, "\\r"),
--   };
-- }

-- console.log(blanks);

-- function printLuaAry(ary) {
--   console.log("ar", ary);
--   let rval = "";
--   for (let i = 0; i < ary.length; i++) {
--     console.log("ai", ary[i], ary[i].join(","));
--     rval =
--       rval + "{" + ary[i].join(",") + "}" + (i < ary.length - 1 ? "," : "");
--   }
--   return rval;
-- }

-- var fileData = "";
-- for (let k of Object.keys(diffed_pvp)) {
--   console.log(diffed_pvp[k].edits);
--   fileData += `[${k}] = {["edits"] = {${printLuaAry(
--     diffed_pvp[k].edits
--   )}}, ["text"] = "${diffed_pvp[k].new_words}"},  \n`;
-- }
-- fs.writeFile("pvp_data.lua", fileData, function (err) {
--   console.log(err);
-- });
